<?php
	
	error_reporting(E_ALL);
	ini_set("display_errors", "on");
	
	// root dir for file selector
	$root = "share/";
	
	$path = "";
	$xml = array("dir"=>"", "file"=>"");
	
	if (isset($_REQUEST["id"])) {
		$path = trim($_REQUEST["id"]);
		$path = preg_replace("/\\\/", "/", $path);			// change \ to /
		$path = preg_replace("/\/?\s{0,}\.{1,}\s{0,}\//", "/", $path);	// change /./ or /../ or /..../ to /
		$path = preg_replace("/\/{2,}/", "/", $path);			// change // and more to single /
		$path = preg_replace("/^\//", "", $path);			// remove leading /
	}
	
	$files = @scandir($root.$path);
	
	if ($files !==false && count($files) > 0) {
		
		/*
		<row id='ID'>
		path/to/	dir should be with trailing /
		path/to/file	file - without
		*/
		
		for ($q=0; $q<count($files); $q++) {
			if (!in_array($files[$q], array(".", "..", ".htaccess"))) {
				$f = $root.$path.$files[$q];
				$xml[(is_dir($f)?"dir":"file")] .= '<row id="'.$path.$files[$q].(is_dir($f)?"/":"").'">'.
										'<cell></cell>'. // empty, grid will detect icon automatically
										'<cell><![CDATA['.$files[$q].']]></cell>'.
										'<cell>'.(is_dir($f)?'':filesize($f)).'</cell>'.
									'</row>';
			}
		}
		
	}
	
	$xml = '<?xml version="1.0" encoding="UTF-8"?><rows>'.$xml["dir"].$xml["file"].'</rows>';
	
	header("Content-Type: text/xml");
	print_r($xml);
	
?>